// (C) Copyright 1999 by Autodesk, Inc. 
//
// Permission to use, copy, modify, and distribute this software in
// object code form for any purpose and without fee is hereby granted, 
// provided that the above copyright notice appears in all copies and 
// that both that copyright notice and the limited warranty and
// restricted rights notice below appear in all supporting 
// documentation.
//
// AUTODESK PROVIDES THIS PROGRAM "AS IS" AND WITH ALL FAULTS. 
// AUTODESK SPECIFICALLY DISCLAIMS ANY IMPLIED WARRANTY OF
// MERCHANTABILITY OR FITNESS FOR A PARTICULAR USE.  AUTODESK, INC. 
// DOES NOT WARRANT THAT THE OPERATION OF THE PROGRAM WILL BE
// UNINTERRUPTED OR ERROR FREE.
//
// Use, duplication, or disclosure by the U.S. Government is subject to 
// restrictions set forth in FAR 52.227-19 (Commercial Computer
// Software - Restricted Rights) and DFAR 252.227-7013(c)(1)(ii)
// (Rights in Technical Data and Computer Software), as applicable.
//
// Created by: Jorge Lopez
//             ObjectDBX Development
//             ADF / Engineering
//             Autodesk, Inc.

//-----------------------------------------------------------------------------
#if !defined(ARX__CONTAINERBAR_H__19990503_175819)
#define ARX__CONTAINERBAR_H__19990503_175819

//-----------------------------------------------------------------------------
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
#include "resource.h"

//-----------------------------------------------------------------------------
class CAcUiContainerBar : public CAcUiDockControlBar 
{
    DECLARE_DYNAMIC(CAcUiContainerBar)

public:
	CAcUiContainerBar (REFCLSID clsid) ;
    ~CAcUiContainerBar();

    void ToggleDocking();
    void ToggleAllowDocking();
    
    void SetEnableDockingCalled(const bool newVal) 
    { 
        m_EnableDockingCalled = newVal; 
    }
    bool GetEnableDockingCalled() const
    { 
        return m_EnableDockingCalled; 
    }

    void SetPreferredDockPosition(const UINT newVal)
    {
        m_PreferredDockPosition = newVal;
    }
    UINT GetPreferredDockPosition() const
    {
        return m_PreferredDockPosition;
    }
    void SetPreferredFloatingRect(const CRect& rect)
    {
        if (m_pPreferredFloatingRect)
            *m_pPreferredFloatingRect = rect;
        else
        {
            m_pPreferredFloatingRect = new CRect(rect);
        }
    }
    CRect* GetPreferredFloatingRect() const
    {
        return m_pPreferredFloatingRect;
    }

	//{{AFX_VIRTUAL(CAcUiContainerBar)
	public:
	virtual BOOL Create(CWnd*pParent, LPCSTR lpszTitle);
	//}}AFX_VIRTUAL

protected:
	//{{AFX_MSG(CAcUiContainerBar)
    afx_msg int OnCreate (LPCREATESTRUCT lpCreateStruct);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

    virtual void SizeChanged (CRect *lpRect, BOOL bFloating, int flags);

private:
	CWnd    m_OCX;
    bool    m_EnableDockingCalled;
    UINT    m_PreferredDockPosition;
    CRect*  m_pPreferredFloatingRect;
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif //----- !defined(ARX__CONTAINERBAR_H__19990503_175819)
